package com.bergerkiller.bukkit.nolagg.itemstacker;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;
import java.util.logging.Level;

import org.bukkit.Material;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;

import com.bergerkiller.bukkit.common.config.FileConfiguration;
import com.bergerkiller.bukkit.common.utils.EnumUtil;
import com.bergerkiller.bukkit.common.utils.ItemUtil;
import com.bergerkiller.bukkit.nolagg.base.NoLaggBase;

public class NoLaggItemStacker extends NoLaggBase {

	public static double stackRadiusSquared = 2.0;
	public static int stackThreshold = 2;
	public static Set<Material> ignoredTypes = new HashSet<Material>();
	public static boolean stackOrbs = true;
	public static int interval;
	
	public static NoLaggItemStacker plugin;
	
	@Override
	public void reload() {
		FileConfiguration config = new FileConfiguration(this);
		boolean regen = !config.exists();
		config.load();
		config.setHeader("This is the configuration of The item stacker of NoLagg\n");
		config.setHeader("radius", "The block radius to look for other items when stacking");
		config.setHeader("threshold", "The amount of (physical) items needed to form one stack");
		config.setHeader("interval", "The interval in ticks at which item stacking is performed (1 tick = 1/20 sec)");
		stackRadiusSquared  = Math.pow(config.get("radius", 1.0), 2);
		stackThreshold = config.get("threshold", 2);
		interval = config.get("interval", 20);
		
		//ignored types
		ignoredTypes.clear();
		if (regen) {
			config.set("ignoredItemTypes", Arrays.asList("DIAMOND_PICKAXE", "WOODEN_HOE"));
		}
		config.setHeader("ignoredItemTypes", "");
		config.addHeader("ignoredItemTypes", "The item types (materials) to ignore during item stacking, buffering and spawn limits");
		config.addHeader("ignoredItemTypes", "Use 'orb' to ignore experience orbs");
		stackOrbs = true;
		for (String type : config.getList("ignoredItemTypes", String.class)) {
			if (type.equalsIgnoreCase("experienceorb") || type.equalsIgnoreCase("xporb") || type.equalsIgnoreCase("orb")) {
				stackOrbs = false;
				continue;
			}
			Material mat = EnumUtil.parseMaterial(type, null);
			if (mat != null) {
				ignoredTypes.add(mat);
			} else {
				log(Level.WARNING, "Unknown item type found in configuration: " + type);
			}
		}
				
		config.save();
	}
	
	public static boolean isIgnoredItem(net.minecraft.server.Entity itementity) {
		return isIgnoredItem(itementity.getBukkitEntity());
	}
	public static boolean isIgnoredItem(Entity itementity) {
		if (ItemUtil.isIgnored(itementity)) return true;
		Item item = (Item) itementity;
		return ignoredTypes.contains(item.getItemStack().getType());
	}
	
	@Override
	public void enable() {
		plugin = this;
		
		this.register(new Commands());
		this.register(NLISListener.class);
		this.reload();
		StackFormer.init();
	}

	@Override
	public void disable() {
		StackFormer.deinit();
	}
	
	@Override
	public void permissions() {}

}
